=== debian/changelog ===
wireshark (1.8.2-5wheezy18) wheezy-security; urgency=medium

  * security fixes from Wireshark 1.12.10:
    - DNP dissector infinite loop (CVE-2016-2523)
    - RSL dissector crash (CVE-2016-2530 CVE-2016-2531)
    - GSM A-bis OML dissector crash
    - ASN.1 BER dissector crashes
  * security fixes from Wireshark 1.12.9:
    - RSL dissector crash (CVE-2015-8731)
    - 802.11 decryption crash (CVE-2015-8723, CVE-2015-8724)
    - ANSI A & GSM A dissector crashes (CVE-2015-8728)
    - DIAMETER dissector crash (CVE-2015-8725)

 -- Balint Reczey <balint@balintreczey.hu>  Thu, 10 Mar 2016 19:25:58 +0100

wireshark (1.8.2-5wheezy17) wheezy-security; urgency=high

  * security fixes from Wireshark 1.12.8:
    - Pcapng file parser crash. Discovered by Dario Lombardo and
      Shannon Sabens. (CVE-2015-7830)
  * security fixes from Wireshark 1.12.7:
    - The ptvcursor implementation could crash (CVE-2015-6248)
    - Crash in the dissector table implementation (CVE-2015-6243)
    - The WaveAgent dissector could crash (CVE-2015-6246)
  * security fixes from Wireshark 1.12.9:
    - DCOM dissector crash (CVE-2015-8714)
    - NLM dissector crash (CVE-2015-8718)
    - BER dissector crash (CVE-2015-8720)
    - Zlib decompression crash (CVE-2015-8721)
    - RSVP dissector crash (CVE-2015-8727)
    - Ascend file parser crash (CVE-2015-8729)

 -- Balint Reczey <balint@balintreczey.hu>  Tue, 01 Mar 2016 21:03:08 +0100

wireshark (1.8.2-5wheezy16) wheezy-security; urgency=high

  * security fixes from Wireshark 1.10.14:
    - The WCP dissector could crash while decompressing data (CVE-2015-3811)

 -- Balint Reczey <balint@balintreczey.hu>  Sat, 23 May 2015 19:29:24 +0200

wireshark (1.8.2-5wheezy15) wheezy-security; urgency=high

  * security fixes from Wireshark 1.12.4 (Closes: #780372):
    - The WCP dissector could crash (CVE-2015-2188)
    - The pcapng file parser could crash (CVE-2015-2189)
    - The TNEF dissector could go into an infinite loop.
      Discovered by Vlad Tsyrklevich. (CVE-2015-2191)

 -- Balint Reczey <balint@balintreczey.hu>  Thu, 26 Mar 2015 21:03:38 +0100

wireshark (1.8.2-5wheezy14) wheezy-security; urgency=high

  * security fixes from Wireshark 1.10.12 (Closes: #776135):
    - The DEC DNA Routing Protocol dissector could crash (CVE-2015-0562)
    - Wireshark could crash while decypting TLS/SSL sessions.
      Discovered by Noam Rathaus. (CVE-2015-0564)

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 25 Jan 2015 15:42:19 +0100

wireshark (1.8.2-5wheezy13) wheezy-security; urgency=high

  * security fixes from Wireshark 1.10.11 (Closes: #769410):
    - SigComp UDVM buffer overflow (CVE-2014-8710)
    - AMQP crash (CVE-2014-8711)
    - NCP crashes (CVE-2014-8712, CVE-2014-8713)
    - TN5250 infinite loops (CVE-2014-8714)

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 23 Nov 2014 12:51:10 +0100

wireshark (1.8.2-5wheezy12) wheezy-security; urgency=high

  * security fixes from Wireshark 1.10.9:
      - RTP dissector crash (CVE-2014-6422)
      - MEGACO dissector infinite loop (CVE-2014-6423)
      - Netflow dissector crash (CVE-2014-6424)
      - RTSP dissector crash (CVE-2014-6427)
      - SES dissector crash (CVE-2014-6428)
      - Sniffer file parser crash.
        (CVE-2014-6429, CVE-2014-6430, CVE-2014-6431, CVE-2014-6432)

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 12 Oct 2014 21:51:38 +0200

wireshark (1.8.2-5wheezy11) wheezy-security; urgency=high

  * security fixes from Wireshark 1.10.9:
    - The Catapult DCT2000 and IrDA dissectors could underrun a buffer
      (CVE-2014-5161, CVE-2014-5162)
    - The GSM Management dissector could crash (CVE-2014-5163)
    - The RLC dissector could crash (CVE-2014-5164)
    - The ASN.1 BER dissector could crash (CVE-2014-5165)

 -- Balint Reczey <balint@balintreczey.hu>  Tue, 05 Aug 2014 10:07:10 +0200

wireshark (1.8.2-5wheezy10) wheezy-security; urgency=low

  * security fixes from Wireshark 1.8.13:
     - The NFS dissector could crash. Discovered by Moshe Kaplan
       (CVE-2014-2281)
     - The RLC dissector could crash. (CVE-2014-2283)
     - The MPEG file parser could overflow a buffer.
       Discovered by Wesley Neelen. (CVE-2014-2299)

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 09 Mar 2014 12:48:21 +0100

wireshark (1.8.2-5wheezy9) wheezy-security; urgency=high

  * security fixes from (not yet released) Wireshark 1.8.13:
    -  The BSSGP dissector could crash. Discovered by Laurent Butti.
       (CVE-2013-7113)
       The exploit provided for CVE-2013-7113 does not crash 1.8.2-5wheezy8
       and earlier versions, but a modified exploit could. The fix is
       back-ported from Wireshark's 1.8.x branch.

 -- Balint Reczey <balint@balintreczey.hu>  Thu, 19 Dec 2013 19:25:08 +0100

wireshark (1.8.2-5wheezy8) wheezy-security; urgency=high

  * security fixes from Wireshark 1.8.12:
    - The NTLMSSP v2 dissector could crash. Discovered by Garming Sam.
      (CVE-2013-7114)

 -- Balint Reczey <balint@balintreczey.hu>  Wed, 18 Dec 2013 16:24:01 +0100

wireshark (1.8.2-5wheezy7) wheezy-security; urgency=high

  * security fixes from Wireshark 1.8.11:
    - The IEEE 802.15.4 dissector could crash. (CVE-2013-6336)
    - The NBAP dissector could crash. Discovered by Laurent Butti.
      (CVE-2013-6337)
    - The SIP dissector could crash.
      (CVE-2013-6338)
    - The TCP dissector could crash. (CVE-2013-6340)

 -- Balint Reczey <balint@balintreczey.hu>  Sat, 02 Nov 2013 16:20:36 +0100

wireshark (1.8.2-5wheezy6) wheezy-security; urgency=high

  * security fixes from Wireshark 1.8.10:
    - NBAP dissector could crash. Discovered by Laurent Butti.
      (No assigned CVE number)
    - The RTPS dissector could overflow a buffer. Discovered by
      Ben Schmidt. (No assigned CVE number)
    - The LDAP dissector could crash. (No assigned CVE number)
    - The Netmon file parser could crash. Discovered by G. Geshev.

 -- Balint Reczey <balint@balintreczey.hu>  Tue, 10 Sep 2013 20:48:24 +0200


